#!/bin/sh
#
# Automatically fetch and apply Sweep IDE updates from Sophos
#
VIRUS_EMAIL=virusalert
ADMIN_EMAIL=,leonb
TOPDIR=/usr/local
#      ^^^^^^^^^^ replace this with your own path to Sweep
#
cd $TOPDIR/tmp
SOPHOS_VERSION=$(
  $TOPDIR/bin/sweep -v |
  /bin/gawk '/^Product version / { print gensub("\\.","","",$4) }'
)
cd $TOPDIR/tmp
rm -f ${SOPHOS_VERSION}_ides.zip wget_results.temp.txt
if ! /usr/bin/wget -q \
  http://www.sophos.com/downloads/ide/${SOPHOS_VERSION}_ides.zip \
  &> wget_results.temp.txt; then
	mail -s 'Failed to fetch Sophos updates, wget error text enclosed' \
	  $VIRUS_EMAIL$ADMIN_EMAIL < wget_results.temp.txt &> /dev/null
	logger -t sophos "Wget error on IDE update ($SOPHOS_VERSION)"
	exit 1
fi
cd $TOPDIR/sav
if /usr/bin/unzip -ou $TOPDIR/tmp/${SOPHOS_VERSION}_ides \
  &> $TOPDIR/tmp/unzip_results.temp.txt; then
	/bin/grep -v ^Archive: <$TOPDIR/tmp/unzip_results.temp.txt | \
	  /bin/mail -s 'The enclosed Sophos virus IDE tags were added (no news is OK)' \
	    $VIRUS_EMAIL$ADMIN_EMAIL &> /dev/null
	logger -t sophos $[
	  $(wc -l $TOPDIR/tmp/unzip_results.temp.txt | \
	  /bin/gawk '{ print $1 }') - 1
	  ] virus IDEs added "(to $SOPHOS_VERSION)"
	exit 0
else
	/bin/mail -s 'Unpacking of Sophos virus IDE tags failed, unzip error enclosed' \
	  $VIRUS_EMAIL$ADMIN_EMAIL < $TOPDIR/tmp/unzip_results.temp.txt &> /dev/null
	logger -t sophos "Unzip error on IDE update ($SOPHOS_VERSION)"
	exit 2
fi
cd $TOPDIR/tmp
rm -f unzip_results.temp.txt wget_results.temp.txt
